var l1 l2 n1 n2 a1f  a1d  a2f a2d h1  h2  m1d m2d m1f m2f P1d P2d P1f P2f w1 w2                                                                  
G1 G2 eta1d eta2d eta1f eta2f lm1d lm2d lm1f lm2f vd  vf  r1  r2  k1  k2  c1  c2  d1  f1  d2  f2  z1  z2 Q x                                     
NPV NPVs LOP STATIC STATICs LOPS;                                                                                                                
                                                                                                                                                 
varexo s1 s2;                                                                                                                                    
parameters m1dss m2dss alf chi eta sig dk dm dh gam bet tet ome1 ome2 phi rho11 rho22 psi lbar tau rho rho12 rho21;                              
alf   =   0.36000000000000;                                                                                                                                                              
chi   =   1.48108172932782;                                                                                                                                                              
sig   =   2.00000000000000;                                                                                                                                                              
dk    =   0.02500000000000;                                                                                                                                                              
dm    =   0.20414107261433;                                                                                                                                                              
dh    =   0.10000000000000;                                                                                                                                                              
gam   =   7.90000000000000;                                                                                                                                                              
bet   =   0.99000000000000;                                                                                                                                                              
tet   =   0.38250000000000;                                                                                                                                                              
ome1  =   0.56058997231364;                                                                                                                                                              
ome2  =   0.43941002768636;                                                                                                                                                              
phi   =  15.60000000000000;                                                                                                                                                              
rho11 =   0.74000000000000;                                                                                                                                                              
rho22 =   0.74000000000000;                                                                                                                                                              
psi   =   0.33840570183832;                                                                                                                                                              
lbar  =   1.00000000000000;                                                                                                                                                              
rho12   =   0.00880000000000;                                                                                                                                                              
rho21  =   0.00880000000000;                                                                                                                                                              
tau   =   0.00000000000000;                                                                                                                                                              
rho   =   1.00000000000000;                                                                                                                                                              
eta   =   0.00000000000000;                                                                                                                                                              
m1dss   =   0.20734486845216;                                                                                                                                                              
m2dss   =   0.03027386969026;                                                                                                                                                              
                                                                                                                                                 
model;                                                                                                                                           
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                            
                                                                                                                                                 
//-------------------------------------------------------------------------                                                                      
//CONSUMERS                                                                                                                                      
                                                                                                                                                 
//Feasibility                                                                                                                                    
-c1 - k1 + G1 + (1-dk)*k1(-1);                                                                                                                   
-c2 - k2 + G2 + (1-dk)*k2(-1);                                                                                                                   
G1-((ome1*d1^((gam-1)/gam)+ome2*(rho*f1)^((gam-1)/gam))^(gam/(gam-1)));                                                                          
G2-((ome2*(rho*d2)^((gam-1)/gam)+ome1*f2^((gam-1)/gam))^(gam/(gam-1)) );                                                                         
//Euler equations                                                                                                                                
bet*psi/c1(+1)*(c1(+1)^psi*(lbar-n1(+1))^(1-psi))^(1-sig)*(r1(+1)+1-dk)                                                                          
- psi/c1*(c1^psi*(lbar-n1)^(1-psi))^(1-sig);                                                                                                     
                                                                                                                                                 
bet*psi/c2(+1)*(c2(+1)^psi*(lbar-n2(+1))^(1-psi))^(1-sig)*(r2(+1)+1-dk)                                                                          
- psi/c2*(c2^psi*(lbar-n2)^(1-psi))^(1-sig);                                                                                                     
                                                                                                                                                 
                                                                                                                                                 
//Static FOCs                                                                                                                                    
(1-psi)*c1 - psi*(lbar-n1)*w1;                                                                                                                   
                                                                                                                                                 
(1-psi)*c2 - psi*(lbar-n2)*w2;                                                                                                                   
                                                                                                                                                 
                                                                                                                                                 
//Risk sharing                                                                                                                                   
Q*1/c1(-1)*(c1(-1)^psi*(lbar-n1(-1))^(1-psi))^(1-sig)  =                                                                                         
 bet*1/c1*(c1^psi*(lbar-n1)^(1-psi))^(1-sig);                                                                                                    
                                                                                                                                                 
x=(1/c2*(c2^psi*(lbar-n2)^(1-psi))^(1-sig))/                                                                                                     
(1/c1*(c1^psi*(lbar-n1)^(1-psi))^(1-sig));                                                                                                       
                                                                                                                                                 
// Prices                                                                                                                                        
                                                                                                                                                 
P1d = ome1*d1^(-1/gam)*(ome1*d1^((gam-1)/gam) + ome2*(rho*f1)^((gam-1)/gam))^(1/(gam-1));                                                        
P2d = ome2*(rho*d2)^(-1/gam)*(ome1*f2^((gam-1)/gam) + ome2*(rho*d2)^((gam-1)/gam))^(1/(gam-1));                                                  
P1f = ome2*(rho*f1)^(-1/gam)*(ome1*d1^((gam-1)/gam) + ome2*(rho*f1)^((gam-1)/gam))^(1/(gam-1));                                                  
P2f = ome1*f2^(-1/gam)*(ome1*f2^((gam-1)/gam) + ome2*(rho*d2)^((gam-1)/gam))^(1/(gam-1));                                                        
                                                                                                                                                 
                                                                                                                                                 
//-------------------------------------------------------------------------                                                                      
//PRODUCERS                                                                                                                                      
                                                                                                                                                 
//These come out of cost minimization                                                                                                            
vd*z1*(1-alf) = (r1^alf)*w1^(1-alf)*((1-alf)/alf)^alf;                                                                                           
vf*z2*(1-alf) = (r2^alf)*w2^(1-alf)*((1-alf)/alf)^alf;                                                                                           
l1*z1 = (d1+(1+tau)*d2+a1d+a1f+chi*h1)*((r1*(1-alf))/(w1*alf))^alf;                                                                              
l2*z2 = ((1+tau)*f1+f2+a2d+a2f+chi*h2)*((r2*(1-alf))/(w2*alf))^alf;                                                                              
k1(-1)*z1 = (d1+(1+tau)*d2+a1d+a1f+chi*h1)*((w1*alf)/(r1*(1-alf)))^(1-alf);                                                                      
k2(-1)*z2 = ((1+tau)*f1+f2+a2d+a2f+chi*h2)*((w2*alf)/(r2*(1-alf)))^(1-alf);                                                                      
                                                                                                                                                 
//Laws of motion for m                                                                                                                           
m1f = m1f(-1)*(1-dm) + a1f - phi*m1f(-1)*(a1f/m1f(-1)-dm)^2;                                                                                     
m2f = m2f(-1)*(1-dm) + a2f - phi*m2f(-1)*(a2f/m2f(-1)-dm)^2;                                                                                     
m1d = m1d(-1)*(1-dm) + a1d - phi*m1d(-1)*(a1d/m1d(-1)-dm)^2;                                                                                     
m2d = m2d(-1)*(1-dm) + a2d - phi*m2d(-1)*(a2d/m2d(-1)-dm)^2;                                                                                     
                                                                                                                                                 
//First order conditions of producers                                                                                                            
                                                                                                                                                 
//Domestic                                                                                                                                       
lm1d = tet*(P1d-eta*vd-vd) + (1-dh)*Q(+1)*lm1d(+1);                                                                                              
lm2d = tet*(x*rho*(P2d/(1+tau))-vd)+ (1-dh)*Q(+1)*lm2d(+1);                                                                                      
lm1d = ((m1d+m1f)/h1) * (vd/(1-2*phi*(a1d/m1d(-1)-dm)) -                                                                                         
       ( Q(+1)*vd(+1)*(1-dm-phi*(dm^2 - (a1d(+1)/m1d)^2))/(1-2*phi*(a1d(+1)/m1d-dm)) ));                                                         
lm2d = ((m2d+m2f)/h2) * (x*vf/(1-2*phi*(a2d/m2d(-1)-dm)) -                                                                                       
       ( Q(+1)*x(+1)*vf(+1)*(1-dm-phi*(dm^2 - (a2d(+1)/m2d)^2))/(1-2*phi*(a2d(+1)/m2d-dm)) ));                                                   
                                                                                                                                                 
//Foreign                                                                                                                                        
lm1f = tet*(rho*(P1f/(1+tau)-eta*vd)/x-vf) + (1-dh)*Q(+1)*x(+1)*lm1f(+1)/x;                                                                      
lm2f = tet*(P2f-eta*vf-vf) + (1-dh)*Q(+1)*x(+1)*lm2f(+1)/x;                                                                                      
lm1f = ((m1d+m1f)/h1) * (vd/(x*(1-2*phi*(a1f/m1f(-1)-dm))) -                                                                                     
       ( Q(+1)*(1/x)*vd(+1)*(1-dm-phi*(dm^2 - (a1f(+1)/m1f)^2))/(1-2*phi*(a1f(+1)/m1f-dm)) ));                                                   
lm2f = ((m2d+m2f)/h2) * (vf/(1-2*phi*(a2f/m2f(-1)-dm)) -                                                                                         
       ( Q(+1)*(x(+1)/x)*vf(+1)*(1-dm-phi*(dm^2 - (a2f(+1)/m2f)^2))/(1-2*phi*(a2f(+1)/m2f-dm)) ));                                               
                                                                                                                                                 
                                                                                                                                                 
//-------------------------------------------------------------------------                                                                      
//INTERMEDIARIES                                                                                                                                 
                                                                                                                                                 
//First order conditions of the Intermediaries                                                                                                   
                                                                                                                                                 
//Domestic                                                                                                                                       
chi*vd = eta1d*m1d/(m1d+m1f) + eta1f*(1-m1d/(m1d+m1f));                                                                                          
eta1d = (1-tet)*(P1d-eta*vd-vd) + (1-dh)*Q(+1)*eta1d(+1);                                                                                        
eta1f = (1-tet)*(rho*(P1f/(1+tau))-x*vf) + (1-dh)*Q(+1)*eta1f(+1);                                                                               
                                                                                                                                                 
//Foreign                                                                                                                                        
chi*vf = eta2d*(1-m2f/(m2d+m2f)) + eta2f*m2f/(m2d+m2f);                                                                                          
eta2d = (1-tet)*(rho*(P2d/(1+tau))-vd/x) + (1-dh)*Q(+1)*x(+1)*eta2d(+1)/x;                                                                       
eta2f = (1-tet)*(P2f-vf) + (1-dh)*Q(+1)*x(+1)*eta2f(+1)/x;                                                                                       
                                                                                                                                                 
//Law of motion for Hs                                                                                                                           
d1 = (1-dh)*d1(-1) + (m1d/(m1d+m1f))*h1;                                                                                                         
f1 = (1-dh)*f1(-1) + (1-m1d/(m1d+m1f))*h1;                                                                                                       
f2 = (1-dh)*f2(-1) + (m2f/(m2d+m2f))*h2;                                                                                                         
d2 = (1-dh)*d2(-1) + (1-m2f/(m2d+m2f))*h2;                                                                                                       
                                                                                                                                                 
//-------------------------------------------------------------------------                                                                      
//MARKET CLEARING AND OTHER CONDITIONS                                                                                                           
                                                                                                                                                 
//Labor market clearing                                                                                                                          
n1 = l1;                                                                                                                                         
n2 = l2;                                                                                                                                         
                                                                                                                                                 
//Shock process                                                                                                                                  
log(z1)=rho11*log(z1(-1))+rho12*log(z2(-1))+s1;                                                                                                  
log(z2)=rho22*log(z2(-1))+rho21*log(z1(-1))+s2;                                                                                                  
                                                                                                                                                 
                                                                                                                                                 
NPV=   tet*chi*(vd - (1-dh)*Q(+1)*vd(+1))/(1-tet);                                                                                               
NPVs= tet*chi*(x*vf - (1-dh)*Q(+1)*x(+1)*vf(+1))/(1-tet);                                                                                        
LOP= NPVs -  NPV;                                                                                                                                
STATIC = ((m1d+m1f)/h1) * (vd/(1-2*phi*(a1d/m1dss-dm)) -                                                                                         
       ( Q(+1)*vd(+1)*(1-dm-0*(dm^2 - (a1d(+1)/m1dss)^2))/(1-2*phi*(a1d(+1)/m1dss-dm)) ));                                                       
STATICs = ((m2d+m2f)/h2) * (x*vf/(1-2*phi*(a2d/m2dss-dm)) -                                                                                      
       ( Q(+1)*x(+1)*vf(+1)*(1-dm-0*(dm^2 - (a2d(+1)/m2dss)^2))/(1-2*phi*(a2d(+1)/m2dss-dm)) ));                                                 
LOPS= STATICs - (1-dh)*Q(+1)*STATICs(+1) - (STATIC - (1-dh)*Q(+1)*STATIC(+1)) ;                                                                  
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                      
end;                                                                                                                                             
                                                                                                                                                 
initval;                                                                                                                                         
                                                                                                                                                 
Q    =   0.99000000000000;                                                                                                                                                              
x    =   1.00000000000000;                                                                                                                                                              
l1  =   0.30000000000000;                                                                                                                                                              
l2  =   0.30000000000000;                                                                                                                                                              
n1   =   0.30000000000000;                                                                                                                                                              
n2   =   0.30000000000000;                                                                                                                                                              
a1f  =   0.00618014023076;                                                                                                                                                              
a1d  =   0.04232760384690;                                                                                                                                                              
a2f  =   0.04232760384690;                                                                                                                                                              
a2d  =   0.00618014023076;                                                                                                                                                              
h1   =   0.05493475087995;                                                                                                                                                              
h2   =   0.05493475087995;                                                                                                                                                              
m1d  =   0.20734486845216;                                                                                                                                                              
m2d  =   0.03027386969026;                                                                                                                                                              
m1f  =   0.03027386969026;                                                                                                                                                              
m2f  =   0.20734486845216;                                                                                                                                                              
P1d  =   0.52576902220580;                                                                                                                                                              
P2d  =   0.52576902220580;                                                                                                                                                              
P1f  =   0.52576902220580;                                                                                                                                                              
P2f  =   0.52576902220580;                                                                                                                                                              
eta1d=   0.61731686307379;                                                                                                                                                              
eta2d=   0.61731686307379;                                                                                                                                                              
eta1f=   0.61731686307379;                                                                                                                                                              
eta2f=   0.61731686307379;                                                                                                                                                              
lm1d =   0.38238655890806;                                                                                                                                                              
lm2d =   0.38238655890806;                                                                                                                                                              
lm1f =   0.38238655890806;                                                                                                                                                              
lm2f =   0.38238655890806;                                                                                                                                                              
vd   =   0.41680134920978;                                                                                                                                                              
vf   =   0.41680134920978;                                                                                                                                                              
r1   =   0.03510101010101;                                                                                                                                                              
r2   =   0.03510101010101;                                                                                                                                                              
k1   =   2.90349617829546;                                                                                                                                                              
k2   =   2.90349617829546;                                                                                                                                                              
c1   =   0.21624249809533;                                                                                                                                                              
c2   =   0.21624249809533;                                                                                                                                                              
d1   =   0.47935776377319;                                                                                                                                                              
f1   =   0.06998974502633;                                                                                                                                                              
d2   =   0.06998974502633;                                                                                                                                                              
f2   =   0.47935776377319;                                                                                                                                                              
z1   =   1.00000000000000;                                                                                                                                                              
z2   =   1.00000000000000;                                                                                                                                                              
w1   =   0.60394458478574;                                                                                                                                                              
w2   =   0.60394458478574;                                                                                                                                                              
G1   =   0.28882990255272;                                                                                                                                                              
G2   =   0.28882990255272;                                                                                                                                                              
NPV   =   0.04168013492098;                                                                                                                                                              
NPVs   =   0.04168013492098;                                                                                                                                                              
LOP   =   0.00000000000000;                                                                                                                                                              
STATIC   =   0.38238655890806;                                                                                                                                                              
STATICs   =   0.38238655890806;                                                                                                                                                              
LOPS   =   0.00000000000000;                                                                                                                                                              
                                                                                                                                                 
                                                                                                                                                 
end;                                                                                                                                             
                                                                                                                                                 
vcov =[   0.00009300000000   0.00001953000000;   0.00001953000000   0.00009300000000];
                                                                                                                                                 
order =1;                                                                                                                                                              
                                                                                                                                                 
                                                                                                                                                 
                                                                                                                                                 
                                                                                                                                                 
